<div class="h-full">
  <!-- first check: any image urls? -->
  <ng-container
    *ngIf="imageLinks?.length > 0; then hasImages; else noImages"
  ></ng-container>

  <!-- (first check) image urls available -->
  <ng-template #hasImages>
    <!-- second check: more than one image? -->
    <ng-container
      *ngIf="imageLinks?.length === 1; then singleImage; else multiImage"
    ></ng-container>

    <!-- (second check) one image -->
    <ng-template #singleImage>
      <div class="centereing-container">
        <span class="mat-tab-label mat-tab-label-content">
          {{ tabLables[0] }}
        </span>
        <shared-result-display
          [imageLink]="imageLinks[0]"
        ></shared-result-display>
      </div>
    </ng-template>

    <!-- (second check) more than one image -->
    <ng-template #multiImage>
      <mat-tab-group
        class="h-full"
        mat-stretch-tabs="true"
        mat-align-tabs="center"
        animationDuration="1000ms"
      >
        <mat-tab *ngFor="let image of imageLinks; let i = index">
          <ng-template mat-tab-label> {{ tabLables[i] }} </ng-template>
          <ng-template matTabContent>
            <div class="centereing-container">
              <shared-result-display
                [imageLink]="imageLinks[i]"
              ></shared-result-display>
            </div>
          </ng-template>
        </mat-tab>

        <mat-tab *ngIf="hasResultTable">
          <ng-template mat-tab-label> {{ resultTableLabel }} </ng-template>
          <ng-content select="[result-table]"></ng-content>
        </mat-tab>
      </mat-tab-group>
    </ng-template>
  </ng-template>

  <!-- (first check) no image urls available -->
  <ng-template #noImages>
    <!-- third check: waiting for server? -->
    <ng-container *ngIf="isLoading; then spinner; else noData"></ng-container>

    <!-- (third check) waiting -->
    <ng-template #spinner>
      <div class="centereing-container">
        <mat-spinner></mat-spinner>
      </div>
    </ng-template>
    <ng-template #noData>
      <div class="centereing-container bg-grey text-grey">
        <p>no data yet, please submit an input</p>
      </div>
    </ng-template>
  </ng-template>
</div>
